//------------------------------------------------------------------------
// This file was autogenerated and you should not edit it. It will be 
// regenerated whenever the schema changes and Neo.Core depends on its
// contents. All changes should be made in Title.cs. 
//------------------------------------------------------------------------

namespace Pubs4.Model
{
	using System;
	using System.Collections;
	using System.Collections.Specialized;
	using System.Data;
	using System.Data.Common;
	using Neo.Core;
	using Neo.Framework;
			
//-------- Base Class ----------------------------------------------------

public class TitleBase : EntityObject
{
	public readonly TitleAuthorRelation TitleAuthors;
       
	protected TitleBase(System.Data.DataRow aRow, Neo.Core.ObjectContext aContext) : base(aRow, aContext)
	{
		TitleAuthors = new TitleAuthorRelation(this, aRow.Table.DataSet.Relations["titles.titleauthor"]);
	}
	
	public virtual System.String Type
	{
		get { return Row["type"] as System.String; }
		set { Row["type"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.Int32 Royalty
	{
		get { object v = Row["royalty"]; return (System.Int32)((v != DBNull.Value) ? v : HandleNullValueForProperty("Royalty")); }
		set { Row["royalty"] = value; }
	}    

	public virtual System.Decimal Price
	{
		get { object v = Row["price"]; return (System.Decimal)((v != DBNull.Value) ? v : HandleNullValueForProperty("Price")); }
		set { Row["price"] = value; }
	}    

	public virtual System.String TitleId
	{
		get { return Row["title_id"] as System.String; }
		set { Row["title_id"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.String Notes
	{
		get { return Row["notes"] as System.String; }
		set { Row["notes"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.Decimal Advance
	{
		get { object v = Row["advance"]; return (System.Decimal)((v != DBNull.Value) ? v : HandleNullValueForProperty("Advance")); }
		set { Row["advance"] = value; }
	}    

	public virtual System.DateTime PublicationDate
	{
		get { object v = Row["pubdate"]; return (System.DateTime)((v != DBNull.Value) ? v : HandleNullValueForProperty("PublicationDate")); }
		set { Row["pubdate"] = value; }
	}    

	public virtual System.String TheTitle
	{
		get { return Row["title"] as System.String; }
		set { Row["title"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.Int32 YtdSales
	{
		get { object v = Row["ytd_sales"]; return (System.Int32)((v != DBNull.Value) ? v : HandleNullValueForProperty("YtdSales")); }
		set { Row["ytd_sales"] = value; }
	}    


	public virtual Publisher Publisher
	{
		get { return (Publisher)Context.GetObjectFromTable("publishers", new object[] { Row["pub_id"] }); }
		set { Row["pub_id"] = (value != null) ? value.Row["pub_id"] : null; }
	}


}

//-------- Query Template ------------------------------------------------

public class TitleTemplate : IFetchSpecification
{
	private IEntityMap entityMap;
	private ListDictionary queryValues;
	private int fetchLimit;
	
	public TitleTemplate(IEntityMap anEntityMap)
	{
		entityMap = anEntityMap;
		queryValues = new ListDictionary();
		fetchLimit = -1;
	}

	public IEntityMap EntityMap 
	{ 
		get { return entityMap; } 
	}

	public Qualifier Qualifier
	{
		get { return Qualifier.FromPropertyDictionary(queryValues); }
	}
	
	public Int32 FetchLimit
	{
		get { return fetchLimit; }
		set { fetchLimit = value; }
	}
	

	public System.String Type
	{
		get { return (System.String)queryValues["Type"]; }
		set { queryValues["Type"] = value; }
	}

	public System.Int32 Royalty
	{
		get { return (System.Int32)queryValues["Royalty"]; }
		set { queryValues["Royalty"] = value; }
	}

	public System.Decimal Price
	{
		get { return (System.Decimal)queryValues["Price"]; }
		set { queryValues["Price"] = value; }
	}

	public System.String TitleId
	{
		get { return (System.String)queryValues["TitleId"]; }
		set { queryValues["TitleId"] = value; }
	}

	public System.String Notes
	{
		get { return (System.String)queryValues["Notes"]; }
		set { queryValues["Notes"] = value; }
	}

	public System.Decimal Advance
	{
		get { return (System.Decimal)queryValues["Advance"]; }
		set { queryValues["Advance"] = value; }
	}

	public System.DateTime PublicationDate
	{
		get { return (System.DateTime)queryValues["PublicationDate"]; }
		set { queryValues["PublicationDate"] = value; }
	}

	public System.String TheTitle
	{
		get { return (System.String)queryValues["TheTitle"]; }
		set { queryValues["TheTitle"] = value; }
	}

	public System.Int32 YtdSales
	{
		get { return (System.Int32)queryValues["YtdSales"]; }
		set { queryValues["YtdSales"] = value; }
	}

	public Publisher Publisher
	{
		get { return (Publisher)queryValues["Publisher"]; }
		set { queryValues["Publisher"] = value; }
	}

               
}


//-------- Typed Collections ----------------------------------------------

public class TitleList : ObjectListBase
{
	public TitleList()
	{
	}

	public TitleList(IList list)
	{
		((ArrayList)InnerList).AddRange(list);
	}

	public Title this[int index]
	{
		get { return (Title)InnerList[index]; }
	}

	public int Add(Title newTitle)
	{
		return base.Add(newTitle);
	}

	public void Remove(Title existingTitle)
	{
		base.Remove(existingTitle);
	}

	public bool Contains(Title existingTitle)
	{
		return base.Contains(existingTitle);
	}

	public int IndexOf(Title existingTitle)
	{
		return base.IndexOf(existingTitle);
	}
	
	public TitleList Find(string qualifierFormat, params object[] parameters)
	{
		TitleList resultSet = new TitleList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Title FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Title)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Title FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Title)base.FindFirst(qualifierFormat, parameters);
	}

}


public class TitleRelation : ObjectRelationBase
{
	public TitleRelation(IEntityObject eo, DataRelation aRelation) : base(eo, aRelation)
	{
	}

	public Title this[int index]
	{
		get { return (Title)InnerList[index]; }
	}

	public int Add(Title newTitle)
	{
		return base.Add(newTitle);
	}

	public void Remove(Title existingTitle)
	{
		base.Remove(existingTitle);
	}

	public bool Contains(Title existingTitle)
	{
		return base.Contains(existingTitle);
	}

	public int IndexOf(Title existingTitle)
	{
		return base.IndexOf(existingTitle);
	}

	public TitleList GetReadOnlyList()
	{
		TitleList resultSet = new TitleList();
		base.CopyToListAndMakeReadOnly(resultSet);
		return resultSet;
	}
	
	public TitleList GetSortedList(string propName, SortDirection dir)
	{
		TitleList resultSet = new TitleList();
		base.CopyToListAndSort(resultSet, propName, dir);
		return resultSet;
	}

	public TitleList Find(string qualifierFormat, params object[] parameters)
	{
		TitleList resultSet = new TitleList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Title FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Title)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Title FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Title)base.FindFirst(qualifierFormat, parameters);
	}

}


//-------- Object Factory ------------------------------------------------

public class TitleFactory : Neo.Framework.ObjectFactory
{
	public TitleFactory(ObjectContext context) : base(context, typeof(Title))
	{
	}

	public Title CreateObject(System.String pkvalue)
	{
		return (Title)base.CreateObject(new object[] { pkvalue });
	}

	public Title FindObject(System.String pkvalue)
	{
		return (Title)base.FindObject(new object[] { pkvalue });
	}

	public new TitleList FindAllObjects()
	{
		TitleList c = new TitleList();
		foreach(Title eo in base.FindAllObjects())
			c.Add(eo);
		return c;
	}
	
	public TitleTemplate GetQueryTemplate()
	{
		return new TitleTemplate(EntityMap);
	}
	

	public TitleList Find(TitleTemplate template)
	{
		TitleList c = new TitleList();
		foreach(Title eo in base.Find(template))
			c.Add(eo);
		return c;
	}

	public new TitleList Find(string qualifierFormat, params object[] parameters)
	{
		TitleList c = new TitleList();
		foreach(Title eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}

	public new TitleList FindWithLimit(int limit, string qualifierFormat, params object[] parameters)
	{
		TitleList c = new TitleList();
		foreach(Title eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}
	
	public new Title FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Title)base.FindFirst(qualifierFormat, parameters);
	}

	public new Title FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Title)base.FindUnique(qualifierFormat, parameters);
	}	

	
}


//-------- Entity Map -----------------------------------------------------

// Should not be instantiated by anybody but the entity map factory which uses reflection...

internal class TitleMap : EntityMap
{
    private static readonly string[] pkcolumns = { "title_id" };
    private static readonly string[] columns = { "type", "royalty", "price", "title_id", "notes", "advance", "pubdate", "pub_id", "title", "ytd_sales" };
    private static readonly string[] attributes = { "Type", "Royalty", "Price", "TitleId", "Notes", "Advance", "PublicationDate", "PubId", "TheTitle", "YtdSales" };

    public override System.Type ObjectType
    {
        get { return typeof(Title); }
    }
    
    public override string TableName
    {
        get { return "titles"; }
    }
    
    public override string[] PrimaryKeyColumns
    {
        get { return pkcolumns; }
    }

    public override string[] Columns
    {
        get { return columns; }
    }

    public override string[] Attributes
    {
        get { return attributes; }
    }

	public override IPkInitializer GetPkInitializer()
	{
		return new UserPkInitializer();
	}
    
    public override string[] RelatedTables
    {
		get { return new string[] { "publishers", "titleauthor" }; }
	}
    
    protected override void WriteBasicSchema(DataTable table)
    {
		DataColumn		c;
		
		c = table.Columns.Add("type", typeof(System.String));
		c = table.Columns.Add("royalty", typeof(System.Int32));
		c.AllowDBNull = true;
		c = table.Columns.Add("price", typeof(System.Decimal));
		c.AllowDBNull = true;
		c = table.Columns.Add("title_id", typeof(System.String));
		c.Unique = true;
		c = table.Columns.Add("notes", typeof(System.String));
		c.AllowDBNull = true;
		c = table.Columns.Add("advance", typeof(System.Decimal));
		c.AllowDBNull = true;
		c = table.Columns.Add("pubdate", typeof(System.DateTime));
		c = table.Columns.Add("pub_id", typeof(System.String));
		c.AllowDBNull = true;
		c = table.Columns.Add("title", typeof(System.String));
		c = table.Columns.Add("ytd_sales", typeof(System.Int32));
		c.AllowDBNull = true;
		table.PrimaryKey = new DataColumn[] { table.Columns["title_id"] };
	}
	
	protected override void WriteRelations(DataTable table)
	{
		DataRelation r;
		
		if(table.DataSet.Relations["publishers.titles"] == null)
		{
			r = table.DataSet.Relations.Add("publishers.titles", 
					table.DataSet.Tables["publishers"].Columns["pub_id"],
					table.DataSet.Tables["titles"].Columns["pub_id"]);
			r.ChildKeyConstraint.UpdateRule = Rule.Cascade;
			r.ChildKeyConstraint.DeleteRule = Rule.SetNull;
		}
 		if(table.DataSet.Relations["titles.titleauthor"] == null)
		{
			r = table.DataSet.Relations.Add("titles.titleauthor", 
					table.DataSet.Tables["titles"].Columns["title_id"],
					table.DataSet.Tables["titleauthor"].Columns["title_id"]);
			r.ChildKeyConstraint.UpdateRule = Rule.Cascade;
			r.ChildKeyConstraint.DeleteRule = Rule.Cascade;
		}
	}
}

	 
}

//------------------------------------------------------------------------
// This file was autogenerated and you should not edit it. It will be 
// regenerated whenever the schema changes and Neo.Core depends on its
// contents. All changes should be made in Job.cs. 
//------------------------------------------------------------------------

namespace Pubs4.Model
{
	using System;
	using System.Collections;
	using System.Collections.Specialized;
	using System.Data;
	using System.Data.Common;
	using Neo.Core;
	using Neo.Framework;
	
//-------- Base Class ----------------------------------------------------

public class JobBase : EntityObject
{
       
	protected JobBase(System.Data.DataRow aRow, Neo.Core.ObjectContext aContext) : base(aRow, aContext)
	{
	}
	
	public virtual System.String Description
	{
		get { return Row["job_desc"] as System.String; }
		set { Row["job_desc"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.Int16 JobId
	{
		get { object v = Row["job_id"]; return (System.Int16)((v != DBNull.Value) ? v : HandleNullValueForProperty("JobId")); }
		set { Row["job_id"] = value; }
	}    

	public virtual System.Int16 MaxLevel
	{
		get { object v = Row["max_lvl"]; return (System.Int16)((v != DBNull.Value) ? v : HandleNullValueForProperty("MaxLevel")); }
		set { Row["max_lvl"] = value; }
	}    

	public virtual System.Int16 MinLevel
	{
		get { object v = Row["min_lvl"]; return (System.Int16)((v != DBNull.Value) ? v : HandleNullValueForProperty("MinLevel")); }
		set { Row["min_lvl"] = value; }
	}    



}

//-------- Query Template ------------------------------------------------

public class JobTemplate : IFetchSpecification
{
	private IEntityMap entityMap;
	private ListDictionary queryValues;
	private int fetchLimit;
	
	public JobTemplate(IEntityMap anEntityMap)
	{
		entityMap = anEntityMap;
		queryValues = new ListDictionary();
		fetchLimit = -1;
	}

	public IEntityMap EntityMap 
	{ 
		get { return entityMap; } 
	}

	public Qualifier Qualifier
	{
		get { return Qualifier.FromPropertyDictionary(queryValues); }
	}
	
	public Int32 FetchLimit
	{
		get { return fetchLimit; }
		set { fetchLimit = value; }
	}
	

	public System.String Description
	{
		get { return (System.String)queryValues["Description"]; }
		set { queryValues["Description"] = value; }
	}

	public System.Int16 JobId
	{
		get { return (System.Int16)queryValues["JobId"]; }
		set { queryValues["JobId"] = value; }
	}

	public System.Int16 MaxLevel
	{
		get { return (System.Int16)queryValues["MaxLevel"]; }
		set { queryValues["MaxLevel"] = value; }
	}

	public System.Int16 MinLevel
	{
		get { return (System.Int16)queryValues["MinLevel"]; }
		set { queryValues["MinLevel"] = value; }
	}

               
}


//-------- Typed Collections ----------------------------------------------

public class JobList : ObjectListBase
{
	public JobList()
	{
	}

	public JobList(IList list)
	{
		((ArrayList)InnerList).AddRange(list);
	}

	public Job this[int index]
	{
		get { return (Job)InnerList[index]; }
	}

	public int Add(Job newJob)
	{
		return base.Add(newJob);
	}

	public void Remove(Job existingJob)
	{
		base.Remove(existingJob);
	}

	public bool Contains(Job existingJob)
	{
		return base.Contains(existingJob);
	}

	public int IndexOf(Job existingJob)
	{
		return base.IndexOf(existingJob);
	}
	
	public JobList Find(string qualifierFormat, params object[] parameters)
	{
		JobList resultSet = new JobList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Job FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Job)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Job FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Job)base.FindFirst(qualifierFormat, parameters);
	}

}


public class JobRelation : ObjectRelationBase
{
	public JobRelation(IEntityObject eo, DataRelation aRelation) : base(eo, aRelation)
	{
	}

	public Job this[int index]
	{
		get { return (Job)InnerList[index]; }
	}

	public int Add(Job newJob)
	{
		return base.Add(newJob);
	}

	public void Remove(Job existingJob)
	{
		base.Remove(existingJob);
	}

	public bool Contains(Job existingJob)
	{
		return base.Contains(existingJob);
	}

	public int IndexOf(Job existingJob)
	{
		return base.IndexOf(existingJob);
	}

	public JobList GetReadOnlyList()
	{
		JobList resultSet = new JobList();
		base.CopyToListAndMakeReadOnly(resultSet);
		return resultSet;
	}
	
	public JobList GetSortedList(string propName, SortDirection dir)
	{
		JobList resultSet = new JobList();
		base.CopyToListAndSort(resultSet, propName, dir);
		return resultSet;
	}

	public JobList Find(string qualifierFormat, params object[] parameters)
	{
		JobList resultSet = new JobList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Job FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Job)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Job FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Job)base.FindFirst(qualifierFormat, parameters);
	}

}


//-------- Object Factory ------------------------------------------------

public class JobFactory : Neo.Framework.ObjectFactory
{
	public JobFactory(ObjectContext context) : base(context, typeof(Job))
	{
	}

	public Job CreateObject()
	{
		return (Job)base.CreateObject(null);
	}

	public Job FindObject(System.Int16 pkvalue)
	{
		return (Job)base.FindObject(new object[] { pkvalue });
	}

	public new JobList FindAllObjects()
	{
		JobList c = new JobList();
		foreach(Job eo in base.FindAllObjects())
			c.Add(eo);
		return c;
	}
	
	public JobTemplate GetQueryTemplate()
	{
		return new JobTemplate(EntityMap);
	}
	

	public JobList Find(JobTemplate template)
	{
		JobList c = new JobList();
		foreach(Job eo in base.Find(template))
			c.Add(eo);
		return c;
	}

	public new JobList Find(string qualifierFormat, params object[] parameters)
	{
		JobList c = new JobList();
		foreach(Job eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}

	public new JobList FindWithLimit(int limit, string qualifierFormat, params object[] parameters)
	{
		JobList c = new JobList();
		foreach(Job eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}
	
	public new Job FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Job)base.FindFirst(qualifierFormat, parameters);
	}

	public new Job FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Job)base.FindUnique(qualifierFormat, parameters);
	}	

	
}


//-------- Entity Map -----------------------------------------------------

// Should not be instantiated by anybody but the entity map factory which uses reflection...

internal class JobMap : EntityMap
{
    private static readonly string[] pkcolumns = { "job_id" };
    private static readonly string[] columns = { "job_desc", "job_id", "max_lvl", "min_lvl" };
    private static readonly string[] attributes = { "Description", "JobId", "MaxLevel", "MinLevel" };

    public override System.Type ObjectType
    {
        get { return typeof(Job); }
    }
    
    public override string TableName
    {
        get { return "jobs"; }
    }
    
    public override string[] PrimaryKeyColumns
    {
        get { return pkcolumns; }
    }

    public override string[] Columns
    {
        get { return columns; }
    }

    public override string[] Attributes
    {
        get { return attributes; }
    }

	public override IPkInitializer GetPkInitializer()
	{
		return new NativePkInitializer();
	}
    
    public override string[] RelatedTables
    {
		get { return new string[] { }; }
	}
    
    protected override void WriteBasicSchema(DataTable table)
    {
		DataColumn		c;
		
		c = table.Columns.Add("job_desc", typeof(System.String));
		c = table.Columns.Add("job_id", typeof(System.Int16));
		c.Unique = true;
		c.AutoIncrement = true; c.AutoIncrementSeed = c.AutoIncrementStep = -1;
		c = table.Columns.Add("max_lvl", typeof(System.Int16));
		c = table.Columns.Add("min_lvl", typeof(System.Int16));
		table.PrimaryKey = new DataColumn[] { table.Columns["job_id"] };
	}
	
}

	 
}

//------------------------------------------------------------------------
// This file was autogenerated and you should not edit it. It will be 
// regenerated whenever the schema changes and Neo.Core depends on its
// contents. All changes should be made in Publisher.cs. 
//------------------------------------------------------------------------

namespace Pubs4.Model
{
	using System;
	using System.Collections;
	using System.Collections.Specialized;
	using System.Data;
	using System.Data.Common;
	using Neo.Core;
	using Neo.Framework;
			
//-------- Base Class ----------------------------------------------------

public class PublisherBase : EntityObject
{
	public readonly TitleRelation Titles;
       
	protected PublisherBase(System.Data.DataRow aRow, Neo.Core.ObjectContext aContext) : base(aRow, aContext)
	{
		Titles = new TitleRelation(this, aRow.Table.DataSet.Relations["publishers.titles"]);
	}
	
	public virtual System.String Name
	{
		get { return Row["pub_name"] as System.String; }
		set { Row["pub_name"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.String State
	{
		get { return Row["state"] as System.String; }
		set { Row["state"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.String PubId
	{
		get { return Row["pub_id"] as System.String; }
		set { Row["pub_id"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.String Country
	{
		get { return Row["country"] as System.String; }
		set { Row["country"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.String City
	{
		get { return Row["city"] as System.String; }
		set { Row["city"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    



}

//-------- Query Template ------------------------------------------------

public class PublisherTemplate : IFetchSpecification
{
	private IEntityMap entityMap;
	private ListDictionary queryValues;
	private int fetchLimit;
	
	public PublisherTemplate(IEntityMap anEntityMap)
	{
		entityMap = anEntityMap;
		queryValues = new ListDictionary();
		fetchLimit = -1;
	}

	public IEntityMap EntityMap 
	{ 
		get { return entityMap; } 
	}

	public Qualifier Qualifier
	{
		get { return Qualifier.FromPropertyDictionary(queryValues); }
	}
	
	public Int32 FetchLimit
	{
		get { return fetchLimit; }
		set { fetchLimit = value; }
	}
	

	public System.String Name
	{
		get { return (System.String)queryValues["Name"]; }
		set { queryValues["Name"] = value; }
	}

	public System.String State
	{
		get { return (System.String)queryValues["State"]; }
		set { queryValues["State"] = value; }
	}

	public System.String PubId
	{
		get { return (System.String)queryValues["PubId"]; }
		set { queryValues["PubId"] = value; }
	}

	public System.String Country
	{
		get { return (System.String)queryValues["Country"]; }
		set { queryValues["Country"] = value; }
	}

	public System.String City
	{
		get { return (System.String)queryValues["City"]; }
		set { queryValues["City"] = value; }
	}

               
}


//-------- Typed Collections ----------------------------------------------

public class PublisherList : ObjectListBase
{
	public PublisherList()
	{
	}

	public PublisherList(IList list)
	{
		((ArrayList)InnerList).AddRange(list);
	}

	public Publisher this[int index]
	{
		get { return (Publisher)InnerList[index]; }
	}

	public int Add(Publisher newPublisher)
	{
		return base.Add(newPublisher);
	}

	public void Remove(Publisher existingPublisher)
	{
		base.Remove(existingPublisher);
	}

	public bool Contains(Publisher existingPublisher)
	{
		return base.Contains(existingPublisher);
	}

	public int IndexOf(Publisher existingPublisher)
	{
		return base.IndexOf(existingPublisher);
	}
	
	public PublisherList Find(string qualifierFormat, params object[] parameters)
	{
		PublisherList resultSet = new PublisherList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Publisher FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Publisher)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Publisher FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Publisher)base.FindFirst(qualifierFormat, parameters);
	}

}


public class PublisherRelation : ObjectRelationBase
{
	public PublisherRelation(IEntityObject eo, DataRelation aRelation) : base(eo, aRelation)
	{
	}

	public Publisher this[int index]
	{
		get { return (Publisher)InnerList[index]; }
	}

	public int Add(Publisher newPublisher)
	{
		return base.Add(newPublisher);
	}

	public void Remove(Publisher existingPublisher)
	{
		base.Remove(existingPublisher);
	}

	public bool Contains(Publisher existingPublisher)
	{
		return base.Contains(existingPublisher);
	}

	public int IndexOf(Publisher existingPublisher)
	{
		return base.IndexOf(existingPublisher);
	}

	public PublisherList GetReadOnlyList()
	{
		PublisherList resultSet = new PublisherList();
		base.CopyToListAndMakeReadOnly(resultSet);
		return resultSet;
	}
	
	public PublisherList GetSortedList(string propName, SortDirection dir)
	{
		PublisherList resultSet = new PublisherList();
		base.CopyToListAndSort(resultSet, propName, dir);
		return resultSet;
	}

	public PublisherList Find(string qualifierFormat, params object[] parameters)
	{
		PublisherList resultSet = new PublisherList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Publisher FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Publisher)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Publisher FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Publisher)base.FindFirst(qualifierFormat, parameters);
	}

}


//-------- Object Factory ------------------------------------------------

public class PublisherFactory : Neo.Framework.ObjectFactory
{
	public PublisherFactory(ObjectContext context) : base(context, typeof(Publisher))
	{
	}

	public Publisher CreateObject(System.String pkvalue)
	{
		return (Publisher)base.CreateObject(new object[] { pkvalue });
	}

	public Publisher FindObject(System.String pkvalue)
	{
		return (Publisher)base.FindObject(new object[] { pkvalue });
	}

	public new PublisherList FindAllObjects()
	{
		PublisherList c = new PublisherList();
		foreach(Publisher eo in base.FindAllObjects())
			c.Add(eo);
		return c;
	}
	
	public PublisherTemplate GetQueryTemplate()
	{
		return new PublisherTemplate(EntityMap);
	}
	

	public PublisherList Find(PublisherTemplate template)
	{
		PublisherList c = new PublisherList();
		foreach(Publisher eo in base.Find(template))
			c.Add(eo);
		return c;
	}

	public new PublisherList Find(string qualifierFormat, params object[] parameters)
	{
		PublisherList c = new PublisherList();
		foreach(Publisher eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}

	public new PublisherList FindWithLimit(int limit, string qualifierFormat, params object[] parameters)
	{
		PublisherList c = new PublisherList();
		foreach(Publisher eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}
	
	public new Publisher FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Publisher)base.FindFirst(qualifierFormat, parameters);
	}

	public new Publisher FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Publisher)base.FindUnique(qualifierFormat, parameters);
	}	

	
}


//-------- Entity Map -----------------------------------------------------

// Should not be instantiated by anybody but the entity map factory which uses reflection...

internal class PublisherMap : EntityMap
{
    private static readonly string[] pkcolumns = { "pub_id" };
    private static readonly string[] columns = { "pub_name", "state", "pub_id", "country", "city" };
    private static readonly string[] attributes = { "Name", "State", "PubId", "Country", "City" };

    public override System.Type ObjectType
    {
        get { return typeof(Publisher); }
    }
    
    public override string TableName
    {
        get { return "publishers"; }
    }
    
    public override string[] PrimaryKeyColumns
    {
        get { return pkcolumns; }
    }

    public override string[] Columns
    {
        get { return columns; }
    }

    public override string[] Attributes
    {
        get { return attributes; }
    }

	public override IPkInitializer GetPkInitializer()
	{
		return new UserPkInitializer();
	}
    
    public override string[] RelatedTables
    {
		get { return new string[] { "titles" }; }
	}
    
    protected override void WriteBasicSchema(DataTable table)
    {
		DataColumn		c;
		
		c = table.Columns.Add("pub_name", typeof(System.String));
		c.AllowDBNull = true;
		c = table.Columns.Add("state", typeof(System.String));
		c.AllowDBNull = true;
		c = table.Columns.Add("pub_id", typeof(System.String));
		c.Unique = true;
		c = table.Columns.Add("country", typeof(System.String));
		c.AllowDBNull = true;
		c = table.Columns.Add("city", typeof(System.String));
		c.AllowDBNull = true;
		table.PrimaryKey = new DataColumn[] { table.Columns["pub_id"] };
	}
	
	protected override void WriteRelations(DataTable table)
	{
		DataRelation r;
		
 		if(table.DataSet.Relations["publishers.titles"] == null)
		{
			r = table.DataSet.Relations.Add("publishers.titles", 
					table.DataSet.Tables["publishers"].Columns["pub_id"],
					table.DataSet.Tables["titles"].Columns["pub_id"]);
			r.ChildKeyConstraint.UpdateRule = Rule.Cascade;
			r.ChildKeyConstraint.DeleteRule = Rule.SetNull;
		}
	}
}

	 
}

//------------------------------------------------------------------------
// This file was autogenerated and you should not edit it. It will be 
// regenerated whenever the schema changes and Neo.Core depends on its
// contents. All changes should be made in TitleAuthor.cs. 
//------------------------------------------------------------------------

namespace Pubs4.Model
{
	using System;
	using System.Collections;
	using System.Collections.Specialized;
	using System.Data;
	using System.Data.Common;
	using Neo.Core;
	using Neo.Framework;
			
//-------- Base Class ----------------------------------------------------

public class TitleAuthorBase : EntityObject
{
       
	protected TitleAuthorBase(System.Data.DataRow aRow, Neo.Core.ObjectContext aContext) : base(aRow, aContext)
	{
	}
	

	public virtual Title Title
	{
		get { return (Title)Context.GetObjectFromTable("titles", new object[] { Row["title_id"] }); }
		set { Row["title_id"] = (value != null) ? value.Row["title_id"] : null; }
	}

	public virtual Author Author
	{
		get { return (Author)Context.GetObjectFromTable("authors", new object[] { Row["au_id"] }); }
		set { Row["au_id"] = (value != null) ? value.Row["au_id"] : null; }
	}


}

//-------- Query Template ------------------------------------------------

public class TitleAuthorTemplate : IFetchSpecification
{
	private IEntityMap entityMap;
	private ListDictionary queryValues;
	private int fetchLimit;
	
	public TitleAuthorTemplate(IEntityMap anEntityMap)
	{
		entityMap = anEntityMap;
		queryValues = new ListDictionary();
		fetchLimit = -1;
	}

	public IEntityMap EntityMap 
	{ 
		get { return entityMap; } 
	}

	public Qualifier Qualifier
	{
		get { return Qualifier.FromPropertyDictionary(queryValues); }
	}
	
	public Int32 FetchLimit
	{
		get { return fetchLimit; }
		set { fetchLimit = value; }
	}
	

	public Title Title
	{
		get { return (Title)queryValues["Title"]; }
		set { queryValues["Title"] = value; }
	}

	public Author Author
	{
		get { return (Author)queryValues["Author"]; }
		set { queryValues["Author"] = value; }
	}

               
}


//-------- Typed Collections ----------------------------------------------

public class TitleAuthorList : ObjectListBase
{
	public TitleAuthorList()
	{
	}

	public TitleAuthorList(IList list)
	{
		((ArrayList)InnerList).AddRange(list);
	}

	public TitleAuthor this[int index]
	{
		get { return (TitleAuthor)InnerList[index]; }
	}

	public int Add(TitleAuthor newTitleAuthor)
	{
		return base.Add(newTitleAuthor);
	}

	public void Remove(TitleAuthor existingTitleAuthor)
	{
		base.Remove(existingTitleAuthor);
	}

	public bool Contains(TitleAuthor existingTitleAuthor)
	{
		return base.Contains(existingTitleAuthor);
	}

	public int IndexOf(TitleAuthor existingTitleAuthor)
	{
		return base.IndexOf(existingTitleAuthor);
	}
	
	public TitleAuthorList Find(string qualifierFormat, params object[] parameters)
	{
		TitleAuthorList resultSet = new TitleAuthorList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new TitleAuthor FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (TitleAuthor)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new TitleAuthor FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (TitleAuthor)base.FindFirst(qualifierFormat, parameters);
	}

}


public class TitleAuthorRelation : ObjectRelationBase
{
	public TitleAuthorRelation(IEntityObject eo, DataRelation aRelation) : base(eo, aRelation)
	{
	}

	public TitleAuthor this[int index]
	{
		get { return (TitleAuthor)InnerList[index]; }
	}

	public int Add(TitleAuthor newTitleAuthor)
	{
		return base.Add(newTitleAuthor);
	}

	public void Remove(TitleAuthor existingTitleAuthor)
	{
		base.Remove(existingTitleAuthor);
	}

	public bool Contains(TitleAuthor existingTitleAuthor)
	{
		return base.Contains(existingTitleAuthor);
	}

	public int IndexOf(TitleAuthor existingTitleAuthor)
	{
		return base.IndexOf(existingTitleAuthor);
	}

	public TitleAuthorList GetReadOnlyList()
	{
		TitleAuthorList resultSet = new TitleAuthorList();
		base.CopyToListAndMakeReadOnly(resultSet);
		return resultSet;
	}
	
	public TitleAuthorList GetSortedList(string propName, SortDirection dir)
	{
		TitleAuthorList resultSet = new TitleAuthorList();
		base.CopyToListAndSort(resultSet, propName, dir);
		return resultSet;
	}

	public TitleAuthorList Find(string qualifierFormat, params object[] parameters)
	{
		TitleAuthorList resultSet = new TitleAuthorList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new TitleAuthor FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (TitleAuthor)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new TitleAuthor FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (TitleAuthor)base.FindFirst(qualifierFormat, parameters);
	}

}


//-------- Object Factory ------------------------------------------------

public class TitleAuthorFactory : Neo.Framework.ObjectFactory
{
	public TitleAuthorFactory(ObjectContext context) : base(context, typeof(TitleAuthor))
	{
	}

	public TitleAuthor CreateObject(Author theAuthor, Title theTitle)
	{
		return (TitleAuthor)base.CreateObject( theAuthor.Row["au_id"], theTitle.Row["title_id"]);
	}

	public new TitleAuthor FindObject(object[] pkvalues)
	{
		return (TitleAuthor)base.FindObject(pkvalues);
	}

	public new TitleAuthorList FindAllObjects()
	{
		TitleAuthorList c = new TitleAuthorList();
		foreach(TitleAuthor eo in base.FindAllObjects())
			c.Add(eo);
		return c;
	}
	
	public TitleAuthorTemplate GetQueryTemplate()
	{
		return new TitleAuthorTemplate(EntityMap);
	}
	

	public TitleAuthorList Find(TitleAuthorTemplate template)
	{
		TitleAuthorList c = new TitleAuthorList();
		foreach(TitleAuthor eo in base.Find(template))
			c.Add(eo);
		return c;
	}

	public new TitleAuthorList Find(string qualifierFormat, params object[] parameters)
	{
		TitleAuthorList c = new TitleAuthorList();
		foreach(TitleAuthor eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}

	public new TitleAuthorList FindWithLimit(int limit, string qualifierFormat, params object[] parameters)
	{
		TitleAuthorList c = new TitleAuthorList();
		foreach(TitleAuthor eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}
	
	public new TitleAuthor FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (TitleAuthor)base.FindFirst(qualifierFormat, parameters);
	}

	public new TitleAuthor FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (TitleAuthor)base.FindUnique(qualifierFormat, parameters);
	}	

	
}


//-------- Entity Map -----------------------------------------------------

// Should not be instantiated by anybody but the entity map factory which uses reflection...

internal class TitleAuthorMap : EntityMap
{
    private static readonly string[] pkcolumns = { "au_id", "title_id" };
    private static readonly string[] columns = { "au_id", "title_id" };
    private static readonly string[] attributes = { "AuId", "TitleId" };

    public override System.Type ObjectType
    {
        get { return typeof(TitleAuthor); }
    }
    
    public override string TableName
    {
        get { return "titleauthor"; }
    }
    
    public override string[] PrimaryKeyColumns
    {
        get { return pkcolumns; }
    }

    public override string[] Columns
    {
        get { return columns; }
    }

    public override string[] Attributes
    {
        get { return attributes; }
    }

	public override IPkInitializer GetPkInitializer()
	{
		return new UserPkInitializer();
	}
    
    public override string[] RelatedTables
    {
		get { return new string[] { "titles", "authors" }; }
	}
    
    protected override void WriteBasicSchema(DataTable table)
    {
		DataColumn		c;
		
		c = table.Columns.Add("au_id", typeof(System.String));
		c = table.Columns.Add("title_id", typeof(System.String));
		table.PrimaryKey = new DataColumn[] { table.Columns["au_id"], table.Columns["title_id"] };
	}
	
	protected override void WriteRelations(DataTable table)
	{
		DataRelation r;
		
		if(table.DataSet.Relations["titles.titleauthor"] == null)
		{
			r = table.DataSet.Relations.Add("titles.titleauthor", 
					table.DataSet.Tables["titles"].Columns["title_id"],
					table.DataSet.Tables["titleauthor"].Columns["title_id"]);
			r.ChildKeyConstraint.UpdateRule = Rule.Cascade;
			r.ChildKeyConstraint.DeleteRule = Rule.Cascade;
		}
		if(table.DataSet.Relations["authors.titleauthor"] == null)
		{
			r = table.DataSet.Relations.Add("authors.titleauthor", 
					table.DataSet.Tables["authors"].Columns["au_id"],
					table.DataSet.Tables["titleauthor"].Columns["au_id"]);
			r.ChildKeyConstraint.UpdateRule = Rule.Cascade;
			r.ChildKeyConstraint.DeleteRule = Rule.Cascade;
		}
	}
}

	 
}

//------------------------------------------------------------------------
// This file was autogenerated and you should not edit it. It will be 
// regenerated whenever the schema changes and Neo.Core depends on its
// contents. All changes should be made in Author.cs. 
//------------------------------------------------------------------------

namespace Pubs4.Model
{
	using System;
	using System.Collections;
	using System.Collections.Specialized;
	using System.Data;
	using System.Data.Common;
	using Neo.Core;
	using Neo.Framework;
			
//-------- Base Class ----------------------------------------------------

public class AuthorBase : EntityObject
{
	public readonly TitleAuthorRelation TitleAuthors;
       
	protected AuthorBase(System.Data.DataRow aRow, Neo.Core.ObjectContext aContext) : base(aRow, aContext)
	{
		TitleAuthors = new TitleAuthorRelation(this, aRow.Table.DataSet.Relations["authors.titleauthor"]);
	}
	
	public virtual System.Boolean ContractSigned
	{
		get { object v = Row["contract"]; return (System.Boolean)((v != DBNull.Value) ? v : HandleNullValueForProperty("ContractSigned")); }
		set { Row["contract"] = value; }
	}    

	public virtual System.String FirstName
	{
		get { return Row["au_fname"] as System.String; }
		set { Row["au_fname"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.String Phone
	{
		get { return Row["phone"] as System.String; }
		set { Row["phone"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    

	public virtual System.String LastName
	{
		get { return Row["au_lname"] as System.String; }
		set { Row["au_lname"] = (value != null) ? (object)value : (object)DBNull.Value; }
	}    



}

//-------- Query Template ------------------------------------------------

public class AuthorTemplate : IFetchSpecification
{
	private IEntityMap entityMap;
	private ListDictionary queryValues;
	private int fetchLimit;
	
	public AuthorTemplate(IEntityMap anEntityMap)
	{
		entityMap = anEntityMap;
		queryValues = new ListDictionary();
		fetchLimit = -1;
	}

	public IEntityMap EntityMap 
	{ 
		get { return entityMap; } 
	}

	public Qualifier Qualifier
	{
		get { return Qualifier.FromPropertyDictionary(queryValues); }
	}
	
	public Int32 FetchLimit
	{
		get { return fetchLimit; }
		set { fetchLimit = value; }
	}
	

	public System.Boolean ContractSigned
	{
		get { return (System.Boolean)queryValues["ContractSigned"]; }
		set { queryValues["ContractSigned"] = value; }
	}

	public System.String FirstName
	{
		get { return (System.String)queryValues["FirstName"]; }
		set { queryValues["FirstName"] = value; }
	}

	public System.String Phone
	{
		get { return (System.String)queryValues["Phone"]; }
		set { queryValues["Phone"] = value; }
	}

	public System.String LastName
	{
		get { return (System.String)queryValues["LastName"]; }
		set { queryValues["LastName"] = value; }
	}

               
}


//-------- Typed Collections ----------------------------------------------

public class AuthorList : ObjectListBase
{
	public AuthorList()
	{
	}

	public AuthorList(IList list)
	{
		((ArrayList)InnerList).AddRange(list);
	}

	public Author this[int index]
	{
		get { return (Author)InnerList[index]; }
	}

	public int Add(Author newAuthor)
	{
		return base.Add(newAuthor);
	}

	public void Remove(Author existingAuthor)
	{
		base.Remove(existingAuthor);
	}

	public bool Contains(Author existingAuthor)
	{
		return base.Contains(existingAuthor);
	}

	public int IndexOf(Author existingAuthor)
	{
		return base.IndexOf(existingAuthor);
	}
	
	public AuthorList Find(string qualifierFormat, params object[] parameters)
	{
		AuthorList resultSet = new AuthorList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Author FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Author)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Author FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Author)base.FindFirst(qualifierFormat, parameters);
	}

}


public class AuthorRelation : ObjectRelationBase
{
	public AuthorRelation(IEntityObject eo, DataRelation aRelation) : base(eo, aRelation)
	{
	}

	public Author this[int index]
	{
		get { return (Author)InnerList[index]; }
	}

	public int Add(Author newAuthor)
	{
		return base.Add(newAuthor);
	}

	public void Remove(Author existingAuthor)
	{
		base.Remove(existingAuthor);
	}

	public bool Contains(Author existingAuthor)
	{
		return base.Contains(existingAuthor);
	}

	public int IndexOf(Author existingAuthor)
	{
		return base.IndexOf(existingAuthor);
	}

	public AuthorList GetReadOnlyList()
	{
		AuthorList resultSet = new AuthorList();
		base.CopyToListAndMakeReadOnly(resultSet);
		return resultSet;
	}
	
	public AuthorList GetSortedList(string propName, SortDirection dir)
	{
		AuthorList resultSet = new AuthorList();
		base.CopyToListAndSort(resultSet, propName, dir);
		return resultSet;
	}

	public AuthorList Find(string qualifierFormat, params object[] parameters)
	{
		AuthorList resultSet = new AuthorList();
		base.Find(resultSet, qualifierFormat, parameters);
		return resultSet;
	}

	public new Author FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Author)base.FindUnique(qualifierFormat, parameters);
	}
	
	public new Author FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Author)base.FindFirst(qualifierFormat, parameters);
	}

}


//-------- Object Factory ------------------------------------------------

public class AuthorFactory : Neo.Framework.ObjectFactory
{
	public AuthorFactory(ObjectContext context) : base(context, typeof(Author))
	{
	}

	public Author CreateObject(System.String pkvalue)
	{
		return (Author)base.CreateObject(new object[] { pkvalue });
	}

	public Author FindObject(System.String pkvalue)
	{
		return (Author)base.FindObject(new object[] { pkvalue });
	}

	public new AuthorList FindAllObjects()
	{
		AuthorList c = new AuthorList();
		foreach(Author eo in base.FindAllObjects())
			c.Add(eo);
		return c;
	}
	
	public AuthorTemplate GetQueryTemplate()
	{
		return new AuthorTemplate(EntityMap);
	}
	

	public AuthorList Find(AuthorTemplate template)
	{
		AuthorList c = new AuthorList();
		foreach(Author eo in base.Find(template))
			c.Add(eo);
		return c;
	}

	public new AuthorList Find(string qualifierFormat, params object[] parameters)
	{
		AuthorList c = new AuthorList();
		foreach(Author eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}

	public new AuthorList FindWithLimit(int limit, string qualifierFormat, params object[] parameters)
	{
		AuthorList c = new AuthorList();
		foreach(Author eo in base.Find(qualifierFormat, parameters))
			c.Add(eo);
		return c;
	}
	
	public new Author FindFirst(string qualifierFormat, params object[] parameters)
	{
		return (Author)base.FindFirst(qualifierFormat, parameters);
	}

	public new Author FindUnique(string qualifierFormat, params object[] parameters)
	{
		return (Author)base.FindUnique(qualifierFormat, parameters);
	}	

	
}


//-------- Entity Map -----------------------------------------------------

// Should not be instantiated by anybody but the entity map factory which uses reflection...

internal class AuthorMap : EntityMap
{
    private static readonly string[] pkcolumns = { "au_id" };
    private static readonly string[] columns = { "contract", "au_id", "au_fname", "phone", "au_lname" };
    private static readonly string[] attributes = { "ContractSigned", "AuId", "FirstName", "Phone", "LastName" };

    public override System.Type ObjectType
    {
        get { return typeof(Author); }
    }
    
    public override string TableName
    {
        get { return "authors"; }
    }
    
    public override string[] PrimaryKeyColumns
    {
        get { return pkcolumns; }
    }

    public override string[] Columns
    {
        get { return columns; }
    }

    public override string[] Attributes
    {
        get { return attributes; }
    }

	public override IPkInitializer GetPkInitializer()
	{
		return new UserPkInitializer();
	}
    
    public override string[] RelatedTables
    {
		get { return new string[] { "titleauthor" }; }
	}
    
    protected override void WriteBasicSchema(DataTable table)
    {
		DataColumn		c;
		
		c = table.Columns.Add("contract", typeof(System.Boolean));
		c = table.Columns.Add("au_id", typeof(System.String));
		c.Unique = true;
		c = table.Columns.Add("au_fname", typeof(System.String));
		c = table.Columns.Add("phone", typeof(System.String));
		c = table.Columns.Add("au_lname", typeof(System.String));
		table.PrimaryKey = new DataColumn[] { table.Columns["au_id"] };
	}
	
	protected override void WriteRelations(DataTable table)
	{
		DataRelation r;
		
 		if(table.DataSet.Relations["authors.titleauthor"] == null)
		{
			r = table.DataSet.Relations.Add("authors.titleauthor", 
					table.DataSet.Tables["authors"].Columns["au_id"],
					table.DataSet.Tables["titleauthor"].Columns["au_id"]);
			r.ChildKeyConstraint.UpdateRule = Rule.Cascade;
			r.ChildKeyConstraint.DeleteRule = Rule.Cascade;
		}
	}
}

	 
}

